require "defines"

local fatControllerInit = false
local fatControllerEntity = nil
local unlocked = false
local tech
local defaultGuiSettings = { displayCount = 9, page = 1}

game.onevent(defines.events.ontick, function(event)
	
	if not unlocked then
		if event.tick%120==12 then
			if tech == nil then
				tech = game.players[1].force.technologies["rail-signals"]
			end
			if tech ~= nil then
				unlocked = tech.researched
			end
			
			destroyGui(glob.fatControllerGui)
			destroyGui(glob.fatControllerButtons)
		end
		
		fatControllerInit = false
		return
	end
	
	----------- NOTHING DONE PAST HERE UNLESS RAIL-SIGNALS UNLOCKED. BAD JOO-JOO!!!!!
	
	if fatControllerInit == false then 
		fatControllerInit = true
		
		
		
		if game.players[1].gui.left.fatController ~= nil then
			game.players[1].gui.left.fatController.destroy()
		end
		destroyGui(glob.fatControllerGui)
		destroyGui(glob.fatControllerButtons)
	
		glob.fatControllerGui = game.players[1].gui.left.add({ type="flow", name="fatController", direction="vertical"})--, style="fatcontroller_thin_flow"}) --caption="Fat Controller", 
		glob.fatControllerButtons = game.players[1].gui.top.add({ type="flow", name="fatControllerButtons", direction="horizontal", style="fatcontroller_thin_flow"})
		--game.players[1].gui.top.add({type="button", name="toggleTrainInfo", caption=game.gettext("text-trains") .. " +", style="fatcontroller_button_style"})
		
		 --game.players[1].gui.left.fatController text = {"msg-intro"} caption = {"text-trains"} .. " +"
		glob.fatControllerButtons.add({type="button", name="toggleTrainInfo", caption = {"text-trains-collapsed"}, style="fatcontroller_button_style"})
		
		if glob.guiSettings == nil then
			glob.guiSettings = defaultGuiSettings
			glob.guiSettings.stationFilterList = buildStationFilterList(glob.trains)
		end
		
		if glob.fatControllerGui.trainInfo ~= nil then
			glob.fatControllerGui.trainInfo.destroy()
			--glob.fatControllerGui.add({ type="frame", name="trainInfo", direction="vertical", style="fatcontroller_thin_frame"})
			newTrainInfoWindow(glob.fatControllerGui, glob.guiSettings)
			updateTrains(glob.trains)
			--refreshTrainInfoGui(glob.trains, glob.fatControllerGui.trainInfo, glob.guiSettings, game.players[1].character)
		end

			
		if glob.trains == nil then
			glob.trains = {}
		end
		
		glob.guiSettings.pageCount = getPageCount(glob.trains, glob.guiSettings) 
		
		filterTrainInfoList(glob.trains, glob.guiSettings.activeFilterList)
		
		updateTrains(glob.trains)
		refreshTrainInfoGui(glob.trains, glob.fatControllerGui.trainInfo, glob.guiSettings, game.players[1].character)
	end

	
	if event.tick%10==9  then
		if glob.character == nil and game.players[1].opened ~= nil and game.players[1].opened.valid and isTrainType(game.players[1].opened.type) and game.players[1].opened.train ~= nil and glob.fatControllerButtons.toggleTrain == nil then
			if trainInList(glob.trains, game.players[1].opened.train) then
				glob.fatControllerButtons.add({ type="button", name="toggleTrain", caption={"text-removetrain"}, style="fatcontroller_selected_button"})
			else
				glob.fatControllerButtons.add({ type="button", name="toggleTrain", caption={"text-addtrain"}, style="fatcontroller_selected_button"})
			end
			--addNewTrainGui(glob.fatControllerButtons, game.players[1].opened.train)
		elseif (game.players[1].opened == nil or glob.character ~= nil) and glob.fatControllerButtons.toggleTrain ~= nil  then
			glob.fatControllerButtons.toggleTrain.destroy()
		end

		
	end
	
	if event.tick%60==13 then
		if glob.fatControllerGui.trainInfo ~= nil then
			--updateInventoryCount(glob.trains)
			updateTrains(glob.trains)
			refreshTrainInfoGui(glob.trains, glob.fatControllerGui.trainInfo, glob.guiSettings, game.players[1].character)
			glob.guiSettings.pageCount = getPageCount(glob.trains, glob.guiSettings) 
		end
	end
	
	if glob.followEntity ~= nil then -- Are we in remote camera mode?
		if not glob.followEntity.valid  or game.players[1].vehicle == nil then
			swapPlayer(game.players[1], glob.character)
			if glob.fatControllerButtons.returnToPlayer ~= nil then
				glob.fatControllerButtons.returnToPlayer.destroy()
			end
			
			if not glob.followEntity.valid then
				removeTrainInfoFromEntity(glob.trains, glob.followEntity)
				newTrainInfoWindow(glob.fatControllerGui, glob.guiSettings)
				refreshTrainInfoGui(glob.trains, glob.fatControllerGui.trainInfo, glob.guiSettings, game.players[1].character)
				
			end
			
			glob.character = nil
			glob.followEntity = nil
			
		elseif glob.character ~= nil and glob.character.valid and glob.fatControllerButtons.returnToPlayer == nil then
			glob.fatControllerButtons.add({ type="button", name="returnToPlayer", caption={"text-player"}, style = "fatcontroller_selected_button"})
			--game.players[1].teleport(glob.followEntity.position)
		elseif glob.character ~= nil and not glob.character.valid  then
			game.setgamestate({gamefinished=true, playerwon=false})
		end
	end
	
	--if event.tick%30==4 and glob.fatControllerGui.trainInfo ~= nil then
		--refreshTrainInfoGui(glob.trains, glob.fatControllerGui.trainInfo, glob.guiSettings, game.players[1].character)
	--end
end)

function destroyGui(guiA)
	if guiA ~= nil and guiA.valid then
		guiA.distroy()
	end
end

function buildStationFilterList(trains)
	local newList = {}
	if trains ~= nil then
		for i, trainInfo in ipairs(trains) do
			-- if trainInfo.group ~= nil then
				-- newList[trainInfo.group] = true
			-- end
			if trainInfo.stations ~= nil then
				for station, value in pairs(trainInfo.stations) do
					newList[station] = true
				end
			end
		end
	end
	return newList
end

function getLocomotives(train)
	if train ~= nil and train.valid then
		local locos = {}
		for i,carriage in ipairs(train.carriages) do
			if carriage ~= nil and carriage.valid and isTrainType(carriage.type) then
				table.insert(locos, carriage)
			end
		end
		return locos
	end
end

function getNewTrainInfo(train)
	if train ~= nil then
		local carriages = train.carriages
		if carriages ~= nil and carriages[1] ~= nil and carriages[1].valid then
			local newTrainInfo = {}
			newTrainInfo.train = train
			--newTrainInfo.firstCarriage = getFirstCarriage(train)
			newTrainInfo.locomotives = getLocomotives(train)
			
			--newTrainInfo.display = true
			return newTrainInfo
		end
	end
end

game.onevent(defines.events.onguiclick, function(event)
	local refreshGui = false
	local newInfoWindow = false
	local rematchStationList = false
	
	if (event.element.name == "toggleTrain" and game.players[1].opened ~= nil and isTrainType(game.players[1].opened.type)) then
		--debugLog(game.players[1].opened.type)
		if trainInList(glob.trains, game.players[1].opened.train) then
			removeTrainInfoFromEntity(glob.trains, game.players[1].opened.train.carriages[1])
			rematchStationList = true
			--refreshTrainInfoGui(glob.trains, glob.fatControllerGui.trainInfo, glob.guiSettings)
			newInfoWindow = true
			refreshGui = true
			event.element.caption = {"text-addtrain"}
		else
			local newTrainInfo = getNewTrainInfo(game.players[1].opened.train)
			if newTrainInfo ~= nil then
				table.insert(glob.trains, newTrainInfo)
				--refreshTrainInfoGui(glob.trains, glob.fatControllerGui.trainInfo, glob.guiSettings)
				rematchStationList = true
				newInfoWindow = true
				refreshGui = true
				event.element.caption = {"text-removetrain"}
			end
		end
	elseif event.element.name == "toggleTrainInfo" then
		if glob.fatControllerGui.trainInfo == nil then
			--glob.fatControllerGui.add({ type="frame", name="trainInfo", direction="vertical", style="fatcontroller_thin_frame"})
			--newTrainInfoWindow(glob.fatControllerGui, glob.guiSettings)
			newInfoWindow = true
			--refreshTrainInfoGui(glob.trains, glob.fatControllerGui.trainInfo, glob.guiSettings)
			refreshGui = true
			event.element.caption = {"text-trains"}
		else
			glob.fatControllerGui.trainInfo.destroy()
			event.element.caption = {"text-trains-collapsed"}
		end 
	elseif event.element.name == "returnToPlayer" then
		if glob.character ~= nil then
			if game.players[1].vehicle ~= nil then
				game.players[1].vehicle.passenger = nil
			end
			swapPlayer(game.players[1], glob.character)
			event.element.destroy()
			glob.character = nil
			glob.followEntity = nil 
		end
	elseif endsWith(event.element.name,"_removeTrain") then
		local trainInfo = getTrainInfoFromElementName(glob.trains, event.element.name)
		if trainInfo ~= nil then
			local elementName = event.element.name
			
			if glob.followEntity ~= nil and glob.followEntity.equals(trainInfo.train.carriages[1]) then --Go back to player
				if game.players[1].vehicle ~= nil then
					game.players[1].vehicle.passenger = nil
				end
				swapPlayer(game.players[1], glob.character)
				if glob.fatControllerButtons.returnToPlayer ~= nil then
					glob.fatControllerButtons.returnToPlayer.destroy()
				end
				glob.character = nil
				glob.followEntity = nil
			end
			
			glob.fatControllerGui.trainInfo[trainInfo.guiName].destroy()
			removeTrainInfoFromElementName(glob.trains, elementName)
			
			--newTrainInfoWindow(glob.fatControllerGui, glob.guiSettings)
			--refreshTrainInfoGui(glob.trains, glob.fatControllerGui.trainInfo, glob.guiSettings)
			
			newInfoWindow = true
			refreshGui = true
			rematchStationList = true
		end
	elseif endsWith(event.element.name,"_toggleManualMode") then
		local trainInfo = getTrainInfoFromElementName(glob.trains, event.element.name)
		if trainInfo ~= nil and trainInfo.train ~= nil and trainInfo.train.valid then
			trainInfo.train.manualmode = not trainInfo.train.manualmode
			swapCaption(event.element, "ll", ">")
		end
	elseif endsWith(event.element.name,"_toggleFollowMode") then
		local trainInfo = getTrainInfoFromElementName(glob.trains, event.element.name)
		if trainInfo ~= nil and trainInfo.train ~= nil and trainInfo.train.valid then
			if glob.character == nil then --Move to train
				if trainInfo.train.carriages[1].passenger ~= nil then
					game.players[1].print({"msg-intrain"})
				else
					glob.character = game.players[1].character
					glob.followEntity = trainInfo.train.carriages[1] -- HERE
					
					fatControllerEntity = newFatControllerEntity(game, game.players[1].position)
					swapPlayer(game.players[1],fatControllerEntity)
					event.element.style = "fatcontroller_selected_button"
					trainInfo.train.carriages[1].passenger = game.players[1].character
				end
			elseif glob.followEntity ~= nil and trainInfo.train ~= nil and trainInfo.train.valid then
				if game.players[1].vehicle ~= nil then
					game.players[1].vehicle.passenger = nil
				end
				if glob.followEntity.equals(trainInfo.train.carriages[1]) or trainInfo.train.carriages[1].passenger ~= nil then --Go back to player
					swapPlayer(game.players[1], glob.character)
					event.element.style = "fatcontroller_button_style"
					if glob.fatControllerButtons.returnToPlayer ~= nil then
						glob.fatControllerButtons.returnToPlayer.destroy()
					end
					glob.character = nil
					glob.followEntity = nil
				else -- Go to different train
					
					glob.followEntity = trainInfo.train.carriages[1] -- AND HERE
					event.element.style = "fatcontroller_selected_button"
					
					trainInfo.train.carriages[1].passenger = game.players[1].character
					--game.players[1].vehicle = trainInfo.train.carriages[1]
				end
			end
			
		end
	elseif event.element.name == "page_back" then
		if glob.guiSettings.page > 1 then
			glob.guiSettings.page = glob.guiSettings.page - 1
			--glob.fatControllerGui.trainInfo.trainInfoControls.page_number.caption = glob.guiSettings.page
			--newTrainInfoWindow(glob.fatControllerGui, glob.guiSettings)
			--refreshTrainInfoGui(glob.trains, glob.fatControllerGui.trainInfo, glob.guiSettings)
			newInfoWindow = true
			refreshGui = true
		end
	elseif event.element.name == "page_forward" then
		if glob.guiSettings.page < getPageCount(glob.trains, glob.guiSettings) then
			glob.guiSettings.page = glob.guiSettings.page + 1
			--debugLog(glob.guiSettings.page)
			--newTrainInfoWindow(glob.fatControllerGui, glob.guiSettings)
			--refreshTrainInfoGui(glob.trains, glob.fatControllerGui.trainInfo, glob.guiSettings)
			newInfoWindow = true
			refreshGui = true
		end
	elseif event.element.name == "page_number" then
		togglePageSelectWindow(game.players[1].gui.center, glob.guiSettings)
	elseif event.element.name == "pageSelectOK" then
		local gui = game.players[1].gui.center.pageSelect
		if gui ~= nil then
			
			local newInt = tonumber(gui.pageSelectValue.text)
			
			if newInt then
				if newInt < 1 then
					newInt = 1
				elseif newInt > 50 then
					newInt = 50
				end
				glob.guiSettings.displayCount = newInt
				glob.guiSettings.pageCount = getPageCount(glob.trains, glob.guiSettings) 
				glob.guiSettings.page = 1
				--newTrainInfoWindow(glob.fatControllerGui, glob.guiSettings)
				--refreshTrainInfoGui(glob.trains, glob.fatControllerGui.trainInfo, glob.guiSettings)
				refreshGui = true
				newInfoWindow = true
			else
				game.players[1].print({"msg-notanumber"})
				--newTrainInfoWindow(glob.fatControllerGui, glob.guiSettings)
				--refreshTrainInfoGui(glob.trains, glob.fatControllerGui.trainInfo, glob.guiSettings)
			end
			gui.destroy()
		end
	elseif event.element.name == "toggleStationFilter" then 
		glob.guiSettings.stationFilterList = buildStationFilterList(glob.trains)
		toggleStationFilterWindow(game.players[1].gui.center, glob.guiSettings)
	elseif event.element.name == "clearStationFilter" or event.element.name == "stationFilterClear" then
		if glob.guiSettings.activeFilterList ~= nil then
			glob.guiSettings.activeFilterList = nil
			
			rematchStationList = true
			newInfoWindow = true
			refreshGui = true
		end
		if game.players[1].gui.center.stationFilterWindow ~= nil then
			game.players[1].gui.center.stationFilterWindow.destroy()
		end
	elseif event.element.name == "stationFilterOK" then
		local gui = game.players[1].gui.center.stationFilterWindow
		if gui ~= nil and gui.checkboxGroup ~= nil then
			local newFilter = {}
			local listEmpty = true
			for station,value in pairs(glob.guiSettings.stationFilterList) do
				local checkboxA = gui.checkboxGroup[station .. "_stationFilter"]
				if checkboxA ~= nil and checkboxA.state then
					listEmpty = false
					--debugLog(station)
					newFilter[station] = true
				end
			end
			if not listEmpty then
				glob.guiSettings.activeFilterList = newFilter
				
				--glo.filteredTrains = buildFilteredTrainInfoList(glob.trains, glob.guiSettings.activeFilterList)
			else
				glob.guiSettings.activeFilterList = nil
			end
			
			gui.destroy()
			glob.guiSettings.page = 1
			rematchStationList = true
			newInfoWindow = true
			refreshGui = true
		end
	elseif endsWith(event.element.name,"_stationFilter") then
		local stationName = string.gsub(event.element.name, "_stationFilter", "")
		if event.element.state then
			if glob.guiSettings.activeFilterList == nil then
				glob.guiSettings.activeFilterList = {}
			end
		
			glob.guiSettings.activeFilterList[stationName] = true
		elseif glob.guiSettings.activeFilterList ~= nil then
			glob.guiSettings.activeFilterList[stationName] = nil
			if tableIsEmpty(glob.guiSettings.activeFilterList) then
				glob.guiSettings.activeFilterList = nil
			end
		end
		--debugLog(event.element.name)
		glob.guiSettings.page = 1
		rematchStationList = true
		newInfoWindow = true
		refreshGui = true
	end
	
	if rematchStationList then
		filterTrainInfoList(glob.trains, glob.guiSettings.activeFilterList)
		glob.guiSettings.pageCount = getPageCount(glob.trains, glob.guiSettings) 
	end
	
	if newInfoWindow then
		newTrainInfoWindow(glob.fatControllerGui, glob.guiSettings)
	end
	
	if refreshGui then
		refreshTrainInfoGui(glob.trains, glob.fatControllerGui.trainInfo, glob.guiSettings, game.players[1].character)
	end
	

end)

function swapStyle(guiElement, styleA, styleB)
	if guiElement ~= nil and styleA ~= nil and styleB ~= nil then
		if guiElement.style == styleA then
			guiElement.style = styleB
		elseif guiElement.style == styleB then
			guiElement.style = styleA
		end
	end
end

function swapCaption(guiElement, captionA, captionB)
	if guiElement ~= nil and captionA ~= nil and captionB ~= nil then
		if guiElement.caption == captionA then
			guiElement.caption = captionB
		elseif guiElement.caption == captionB then
			guiElement.caption = captionA
		end
	end

end

function tableIsEmpty(tableA)
	if tableA ~= nil then
		for i,v in pairs(tableA) do
			return false
		end
	end
	return true
end

function toggleStationFilterWindow(gui, guiSettings)
	if gui ~= nil then
		if gui.stationFilterWindow == nil then
			--local sortedList = table.sort(a)
			local window = gui.add({type="frame", name="stationFilterWindow", caption={"msg-stationFilter"}, direction="vertical" }) --style="fatcontroller_thin_frame"}) 
			window.add({type="table", name="checkboxGroup", colspan=3})
			for name, value in pairsByKeys(guiSettings.stationFilterList) do
				if guiSettings.activeFilterList ~= nil and guiSettings.activeFilterList[name] then 
					window.checkboxGroup.add({type="checkbox", name=name .. "_stationFilter", caption=name, state=true}) --style="filter_group_button_style"})
				else
					window.checkboxGroup.add({type="checkbox", name=name .. "_stationFilter", caption=name, state=false}) --style="filter_group_button_style"})
				end
				
				
			end
			window.add({type="flow", name="buttonFlow"})
			window.buttonFlow.add({type="button", name="stationFilterClear", caption={"msg-Clear"}})
			window.buttonFlow.add({type="button", name="stationFilterOK", caption={"msg-OK"}})
			
		else
			gui.stationFilterWindow.destroy()
		end
	end
end



function togglePageSelectWindow(gui, guiSettings)
	if gui ~= nil then
		if gui.pageSelect == nil then
			local window = gui.add({type="frame", name="pageSelect", caption={"msg-displayCount"}, direction="vertical" }) --style="fatcontroller_thin_frame"}) 
			window.add({type="textfield", name="pageSelectValue", text=guiSettings.displayCount .. ""})
			window.pageSelectValue.text = guiSettings.displayCount .. ""
			window.add({type="button", name="pageSelectOK", caption={"msg-OK"}})
		else
			gui.pageSelect.destroy()
		end
	end
end

function getPageCount(trains, guiSettings)
	local trainCount = 0
	for i,trainInfo in ipairs(trains) do
		if guiSettings.activeFilterList == nil or trainInfo.matchesStationFilter then
			trainCount = trainCount + 1
		end
	end
	return math.floor((trainCount - 1) / guiSettings.displayCount) + 1 
end

game.onevent(defines.events.onentitydied, function(event)
	local trainInfo = getTrainInfoFromEntity(glob.trains, event.entity)
	
	if trainInfo ~= nil then

		if glob.followEntity ~= nil and glob.followEntity.equals(trainInfo.train.carriages[1]) then --Go back to player
			if game.players[1].vehicle ~= nil then
				game.players[1].vehicle.passenger = nil
			end
			
			swapPlayer(game.players[1], glob.character)
			
			if glob.fatControllerButtons.returnToPlayer ~= nil then
				glob.fatControllerButtons.returnToPlayer.destroy()
			end
			
			glob.character = nil
			glob.followEntity = nil
		end
		
		removeTrainInfoFromEntity(glob.trains, entity)
		
		if glob.fatControllerGui.trainInfo ~= nil then
			glob.fatControllerGui.trainInfo[trainInfo.guiName].destroy()
			newTrainInfoWindow(glob.fatControllerGui, glob.guiSettings)
			refreshTrainInfoGui(glob.trains, glob.fatControllerGui.trainInfo, glob.guiSettings, game.players[1].character)
		end
		
		

	end
	
end)

game.onevent(defines.events.onpreplayermineditem, function(event)
	local trainInfo = getTrainInfoFromEntity(glob.trains, event.entity)
	
	if trainInfo ~= nil then

		if glob.followEntity ~= nil and glob.followEntity.equals(trainInfo.train.carriages[1]) then --Go back to player
			if game.players[1].vehicle ~= nil then
				game.players[1].vehicle.passenger = nil
			end
			
			swapPlayer(game.players[1], glob.character)
			
			if glob.fatControllerButtons.returnToPlayer ~= nil then
				glob.fatControllerButtons.returnToPlayer.destroy()
			end
			
			glob.character = nil
			glob.followEntity = nil
		end
		
		removeTrainInfoFromEntity(glob.trains, entity)
		
		if glob.fatControllerGui.trainInfo ~= nil then
			glob.fatControllerGui.trainInfo[trainInfo.guiName].destroy()
			newTrainInfoWindow(glob.fatControllerGui, glob.guiSettings)
			refreshTrainInfoGui(glob.trains, glob.fatControllerGui.trainInfo, glob.guiSettings, game.players[1].character)
		end
	end
end)



function isUnlocked(technologies)
	return technologies["rail-signals"].researched 
end

function swapPlayer(player, character)
	--player.teleport(character.position)
	if player.character ~= nil and player.character.valid and player.character.name == "fatcontroller" then
		player.character.destroy()
	end
	player.character = character
end

function isTrainType(type)
	if type == "locomotive" then
		return true
	end
	return false
end

function getTrainInfoFromElementName(trains, elementName)
	for i, trainInfo in ipairs(trains) do
		if trainInfo ~= nil and trainInfo.guiName ~= nil and startsWith(elementName, trainInfo.guiName .. "_") then
			return trainInfo
		end
	end
end


function getTrainInfoFromEntity(trains, entity)
	if trains ~= nil then
		for i, trainInfo in ipairs(trains) do
			if trainInfo ~= nil and trainInfo.train ~= nil and trainInfo.train.valid and entity.equals(trainInfo.train.carriages[1]) then
				return trainInfo
			end
		end
	end
end

function removeTrainInfoFromElementName(trains, elementName)
	for i, trainInfo in ipairs(trains) do
		if trainInfo ~= nil and trainInfo.guiName ~= nil and startsWith(elementName, trainInfo.guiName .. "_") then
			table.remove(trains, i)
			return
		end
	end
end

function removeTrainInfoFromEntity(trains, entity)
	for i, trainInfo in ipairs(trains) do
		if trainInfo ~= nil and trainInfo.train ~= nil and trainInfo.train.valid and trainInfo.train.carriages[1].equals(entity) then
			table.remove(trains, i)
			return
		end
	end
end

function getHighestInventoryCount(trainInfo)
	local inventry = nil
	
	if trainInfo ~= nil and trainInfo.train ~= nil and trainInfo.train.valid and trainInfo.train.carriages ~= nil then
		local itemsCount = 0
		local largestItem = {}
		local items = {}
		
		
		
		for i, carriage in ipairs(trainInfo.train.carriages) do
			if carriage ~= nil and carriage.valid and carriage.type == "cargo-wagon" then
				
				local inv = carriage.getinventory(1)
				local contents = inv.getcontents()
				for name, count in pairs(contents) do
					if items[name] ~= nil then
						items[name] = items[name] + count
					else
						items[name] = count
						itemsCount = itemsCount + 1
					end
					if largestItem.count == nil or largestItem.count < items[name] then
						largestItem.name = name
						largestItem.count = items[name]
					end
				end
			end

		end
		
		if largestItem.name ~= nil then
			--local displayName = game.getlocaliseditemname(largestItem.name)
			-- if startsWith(displayName, "Unknown-key") then
				-- displayName = largestItem.name
			-- end
			local displayName = largestItem.name
			inventory = displayName .. ": " .. largestItem.count
			if itemsCount > 1 then
				inventory = inventory .. "..."
			end
		else
			inventory = ""
		end
	end
	
	return inventory
end

function updateInventoryCount(trains)
	for i, trainInfo in ipairs(trains) do
		if trainInfo.train ~= nil and trainInfo.train.valid and trainInfo.train.speed == 0 then
			local tempInventory = getHighestInventoryCount(trainInfo)
			if tempInventory ~= nil then
				trainInfo.inventory = tempInventory
			end
		end
	end
end

function newFatControllerEntity(game, position)
	game.createentity({name="fatcontroller", position=position, force=game.forces.player})
	local entities = game.findentitiesfiltered({area={{position.x, position.y},{position.x, position.y}}, name="fatcontroller"})
	if entities[1] ~= nil then
		return entities[1]
	end
end

function newTrainInfoWindow(gui, guiSettings)
	if gui ~= nil and gui.trainInfo ~= nil then
		gui.trainInfo.destroy()
	end
	if guiSettings == nil then
		guiSettings = defaultGuiSettings
	end
	
	local newGui = gui.add({ type="flow", name="trainInfo", direction="vertical", style="fatcontroller_thin_flow"})
	
	
	newGui.add({type = "frame", name="trainInfoControls", direction="horizontal", style="fatcontroller_thin_frame"})
	
	newGui.trainInfoControls.add({type = "flow", name="pageButtons",  direction="horizontal", style="fatcontroller_button_flow"})
	
	if guiSettings.page > 1 then
		newGui.trainInfoControls.pageButtons.add({type="button", name="page_back", caption="<", style="fatcontroller_button_style"})
	else
		newGui.trainInfoControls.pageButtons.add({type="button", name="page_back", caption="<", style="fatcontroller_disabled_button"})
	end
	
	newGui.trainInfoControls.pageButtons.add({type="button", name="page_number", caption=guiSettings.page .. "/" .. guiSettings.pageCount, style="fatcontroller_button_style"})
	
	if guiSettings.page < guiSettings.pageCount then
		newGui.trainInfoControls.pageButtons.add({type="button", name="page_forward", caption=">", style="fatcontroller_button_style"})
	else
		newGui.trainInfoControls.pageButtons.add({type="button", name="page_forward", caption=">", style="fatcontroller_disabled_button"})
	end
	
	
	newGui.trainInfoControls.add({type = "flow", name="filterButtons",  direction="horizontal", style="fatcontroller_button_flow"})
	if guiSettings.activeFilterList ~= nil then 
		newGui.trainInfoControls.filterButtons.add({type="button", name="toggleStationFilter", caption="s", style="fatcontroller_selected_button"})
		newGui.trainInfoControls.filterButtons.add({type="button", name="clearStationFilter", caption="x", style="fatcontroller_button_style"})
	else
		newGui.trainInfoControls.filterButtons.add({type="button", name="toggleStationFilter", caption="s", style="fatcontroller_button_style"})
		newGui.trainInfoControls.filterButtons.add({type="button", name="clearStationFilter", caption="x", style="fatcontroller_disabled_button"})
	end
	
	
	

	
	return newGui
end

-- function getFirstCarriage(train)
	-- if train ~= nil and train.valid then
		-- for i, carriage in ipairs(train.carriages) do
			-- if carriage ~= nil and carriage.valid and isTrainType(carriage.type) then
				-- return carriage
			-- end
		-- end
	-- end
-- end

function getTrainFromLocomotives(locomotives)
	if locomotives ~= nil then
		for i,loco in ipairs(locomotives) do
			if loco ~= nil and loco.valid and loco.train ~= nil and loco.train.valid then
				return loco.train
			end
		end
	end
end

function isTrainInfoDuplicate(trains, trainInfoB, index)
	--local trainInfoB = trains[index]
	if trainInfoB ~= nil and trainInfoB.train ~= nil and trainInfoB.train.valid then
		for i, trainInfo in ipairs(trains) do
			--debugLog(i)
			if i ~= index and trainInfo.train ~= nil and trainInfo.train.valid and compareTrains(trainInfo.train, trainInfoB.train) then
				return true
			end
		end
	end
	
	
	return false
end

function compareTrains(trainA, trainB)
	if trainA ~= nil and trainA.valid and trainB ~= nil and trainB.valid and trainA.carriages[1].equals(trainB.carriages[1]) then
		return true
	end
	return false
end

function updateTrains(trains)
	if trains ~= nil then
		for i, trainInfo in ipairs(trains) do
			
			--refresh invalid train objects
			if trainInfo.train == nil or not trainInfo.train.valid then
				trainInfo.train = getTrainFromLocomotives(trainInfo.locomotives)
				trainInfo.locomotives = getLocomotives(trainInfo.train)
				if isTrainInfoDuplicate(trains, trainInfo, i) then
					trainInfo.train = nil
				end
			end
			
			if (trainInfo.train == nil or not trainInfo.train.valid) then
				
				table.remove(trains, i)
			else
				trainInfo.locomotives = getLocomotives(trainInfo.train)
				updateTrainInfo(trainInfo)
				--debugLog(trainInfo.train.state)
			end
		end
	end
end

function updateTrainInfoIfChanged(trainInfo, field, value) 
	if trainInfo ~= nil and field ~= nil and trainInfo[field] ~= value then
		trainInfo[field] = value
		trainInfo.updated = true
		return true
	end
	return false
end


function updateTrainInfo(trainInfo)
	if trainInfo ~= nil then
		trainInfo.updated = false
	
		updateTrainInfoIfChanged(trainInfo, "manualMode", trainInfo.train.manualmode)
		updateTrainInfoIfChanged(trainInfo, "speed", trainInfo.train.speed)
		
		--SET CurrentStationText
		if trainInfo.train.schedule ~= nil and trainInfo.train.schedule.current ~= nil and trainInfo.train.schedule.current ~= 0 then
			if trainInfo.train.schedule.records[trainInfo.train.schedule.current] ~= nil then
				updateTrainInfoIfChanged(trainInfo, "currentStation", trainInfo.train.schedule.records[trainInfo.train.schedule.current].station)
			else
				updateTrainInfoIfChanged(trainInfo, "currentStation", "Auto")
			end
		end
		
		--SET InventoryText
		if trainInfo.train.speed == 0 then
			local tempInventory = getHighestInventoryCount(trainInfo)
			if tempInventory ~= nil then
				updateTrainInfoIfChanged(trainInfo, "inventory",tempInventory)
			end
		end
		
		-- if openEntity ~= nil and containsEntity(trainInfo.locomotives, openEntity) then
			-- updateTrainInfoIfChanged(trainInfo, "open", true)
		-- else
			-- updateTrainInfoIfChanged(trainInfo, "open", false)
		-- end
		
		-- if followEntity ~= nil and trainInfo.train.carriages[1].equals(followEntity) then
			-- updateTrainInfoIfChanged(trainInfo, "follow", true)
		-- else
			-- updateTrainInfoIfChanged(trainInfo, "follow", false)
		-- end
		
		if trainInfo.train.schedule ~= nil and trainInfo.train.schedule.records ~= nil and trainInfo.train.schedule.records[1] ~= nil then
			if trainInfo.stations == nil then
				trainInfo.stations = {}
			end
			for i, record in ipairs(trainInfo.train.schedule.records) do
				trainInfo.stations[record.station] = true
			end
		else
			trainInfo.stations = nil
		end
	end
end

function containsEntity(entityTable, entityA)
	if entityTable ~= nil and entityA ~= nil then
		for i, entityB in ipairs(entityTable) do
			if entityB ~= nil and entityB.equals(entityA) then
				return true
			end
		end
	end
	return false
end

function refreshTrainInfoGui(trains, gui, guiSettings, character)
	if gui ~= nil then
		local removeGuiFromCount = 1
		local removeTrainInfo = {}
		
		local pageStart = ((guiSettings.page - 1) * guiSettings.displayCount) + 1
		--debugLog("Page:" .. pageStart)
		
		local display = 0
		local filteredCount = 0
		
		for i, trainInfo in ipairs(trains) do
			local newGuiName = nil
			
			if display < guiSettings.displayCount then
			
				if guiSettings.activeFilterList == nil or trainInfo.matchesStationFilter then
					filteredCount = filteredCount + 1
					
					newGuiName = "Info" .. filteredCount
					
					if filteredCount >= pageStart then
						--removeGuiFromCount = removeGuiFromCount + 1
						display = display + 1
						--debugLog(newGuiName)
						if trainInfo.updated or gui[newGuiName] == nil then --trainInfo.guiName ~= newGuiName or
							trainInfo.guiName = newGuiName
							
							if gui[trainInfo.guiName] == nil then
								gui.add({ type="frame", name=trainInfo.guiName, direction="horizontal", style="fatcontroller_thin_frame"})
							end
							local trainGui = gui[trainInfo.guiName]
							
							
							--Add buttons
							if trainGui.buttons == nil then
								trainGui.add({type = "flow", name="buttons",  direction="horizontal", style="fatcontroller_traininfo_button_flow"})
							end
							
							if trainGui.buttons[trainInfo.guiName .. "_removeTrain"] == nil then
								trainGui.buttons.add({type="button", name=trainInfo.guiName .. "_removeTrain", caption="x", style="fatcontroller_button_style"})
							end
							

							if trainGui.buttons[trainInfo.guiName .. "_toggleManualMode"] == nil then
								trainGui.buttons.add({type="button", name=trainInfo.guiName .. "_toggleManualMode", caption="ll", style="fatcontroller_button_style"})
							end
							
							if trainInfo.manualMode then 
								trainGui.buttons[trainInfo.guiName .. "_toggleManualMode"].caption = ">"
							else
								trainGui.buttons[trainInfo.guiName .. "_toggleManualMode"].caption = "ll"
							end
							
							
							if trainGui.buttons[trainInfo.guiName .. "_toggleFollowMode"] == nil then
								trainGui.buttons.add({type="button", name=trainInfo.guiName .. "_toggleFollowMode", caption={"text-controlbutton"}, style="fatcontroller_button_style"})
							end
							

							--Add info
							if trainGui.info == nil then
								trainGui.add({type = "flow", name="info",  direction="vertical", style="fatcontroller_thin_flow"})
							end
							
							
							
							if trainGui.info.topInfo == nil then
								trainGui.info.add({type="label", name="topInfo", style="fatcontroller_label_style"})
							end
							if trainGui.info.bottomInfo == nil then
								trainGui.info.add({type="label", name="bottomInfo", style="fatcontroller_label_style"}) 
							end
							
							local topString = ""
							
							if trainInfo.manualMode then
								topString = "Manual" -- REPLACE WITH TRANSLAION
							elseif trainInfo.currentStation ~= nil then
								topString = trainInfo.currentStation
							end
							
							if trainInfo.speed == 0 then
								topString = topString .. ": " .. "Stopped" -- REPLACE WITH TRANSLAION
							else
								topString = topString .. ": " .. "Moving" -- REPLACE WITH TRANSLAION
							end
							
							
							local bottomString = ""
							
							if trainInfo.inventory ~= nil then
								bottomString = trainInfo.inventory
							else
								bottomString = ""
							end
							
							trainGui.info.topInfo.caption = topString
							trainGui.info.bottomInfo.caption = bottomString
						end
						
						if character ~= nil and containsEntity(trainInfo.locomotives, character.opened) then --character.opened ~= nil and
							gui[newGuiName].buttons[trainInfo.guiName .. "_removeTrain"].style = "fatcontroller_selected_button"
						else
							--debugLog("Failed: " .. i)
							gui[newGuiName].buttons[trainInfo.guiName .. "_removeTrain"].style = "fatcontroller_button_style"
						end
						
						if character ~= nil and character.name == "fatcontroller" and containsEntity(trainInfo.locomotives, character.vehicle) then
							gui[newGuiName].buttons[trainInfo.guiName .. "_toggleFollowMode"].style = "fatcontroller_selected_button"
						else
							gui[newGuiName].buttons[trainInfo.guiName .. "_toggleFollowMode"].style = "fatcontroller_button_style"
						end
						
					end
				end
			end
			if newGuiName == nil and trainInfo.guiName ~= nil and gui.newGuiName ~= nil then 
				gui.destroy()
			end
			trainInfo.guiName = newGuiName
		end
		
		--debugLog("display: " .. display .. " fc: " .. filteredCount .. " removeCount: " .. removeGuiFromCount)
		
		-- for i, number in ipairs(trainsToRemove) do
			-- table.remove(trains, number)
		-- end
		-- removeGuiFromCount = display
		-- while gui["Info" .. removeGuiFromCount] ~= nil do
			-- gui["Info" .. removeGuiFromCount].destroy()
			-- removeGuiFromCount = removeGuiFromCount + 1
		-- end
	end
end

function filterTrainInfoList(trains, activeFilterList)
	if trains ~= nil  then
		for i,trainInfo in ipairs(trains) do
			if activeFilterList ~= nil then
				trainInfo.matchesStationFilter = matchStationFilter(trainInfo, activeFilterList) 
				if trainInfo.matchesStationFilter then
					--debugLog("MATCH!: " .. i)
				end
			else
				trainInfo.matchesStationFilter = true
			end
		end

	end
	
end

function matchStationFilter(trainInfo, activeFilterList)
	local fullMatch = false
	if trainInfo ~= nil and trainInfo.stations ~= nil then
		for filter, value in pairs(activeFilterList) do
			if trainInfo.stations[filter] then
				fullMatch = true
			else 
				return false
			end
		end
	end
	
	return fullMatch
end

-- function findTrainInfoFromEntity(trains, entity)
	-- for i, trainInfo in ipairs(trains) do
		-- if train ~= nil and train.valid and train.carriages[1] ~= nil and trainInfo ~= nil and trainInfo.train.carriages[1] ~= nil and entity.equals(trainB.train.carriages[1]) then
			-- return trainInfo
		-- end
	-- end
-- end

function trainInList(trains, train)
	for i, trainInfo in ipairs(trains) do
		if train ~= nil and train.valid and train.carriages[1] ~= nil and trainInfo ~= nil and trainInfo.train ~= nil and trainInfo.train.valid and trainInfo.train.carriages[1] ~= nil and train.carriages[1].equals(trainInfo.train.carriages[1]) then
			return true
		end
	end
	return false
end

-- function addNewTrainGui(gui, train)
	-- if train ~= nil and train.valid and train.carriages[1] ~= nil and train.carriages[1].valid then
		-- if gui.toggleTrain ~= nil then
			-- gui.toggleTrain.destroy()
		-- end
		
	-- end
-- end

function matchStringInTable(stringA, tableA)
	for i, stringB in ipairs(tableA) do
		if stringA == stringB then
			return true
		end
	end
	return false
end

function round(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end

function debugLog(message)
	if false then -- set for debug
		game.players[1].print(message)
	end
end

function endsWith(String,End)
   return End=='' or string.sub(String,-string.len(End))==End
end

function startsWith(String,Start)
	debugLog(String)
	debugLog(Start)
   return string.sub(String,1,string.len(Start))==Start
end

function pairsByKeys (t, f)
	local a = {}
	for n in pairs(t) do table.insert(a, n) end
	table.sort(a, f)
	local i = 0      -- iterator variable
	local iter = function ()   -- iterator function
		i = i + 1
		if a[i] == nil then return nil
			else return a[i], t[a[i]]
		end
	end
	return iter
end